
package net.mcreator.razortyrant.client.renderer;

import net.minecraft.world.level.Level;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.layers.RenderLayer;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.LivingEntityRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.HierarchicalModel;

import net.mcreator.razortyrant.procedures.RazorTyrantWalkPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantModelVisualScaleProcedure;
import net.mcreator.razortyrant.entity.RazorTyrantEntity;
import net.mcreator.razortyrant.client.model.animations.Razor_TyrantAnimation;
import net.mcreator.razortyrant.client.model.ModelRazor_Tyrant;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

public class RazorTyrantRenderer extends MobRenderer<RazorTyrantEntity, ModelRazor_Tyrant<RazorTyrantEntity>> {
	public RazorTyrantRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(ModelRazor_Tyrant.LAYER_LOCATION)), 2f);
		this.addLayer(new RenderLayer<RazorTyrantEntity, ModelRazor_Tyrant<RazorTyrantEntity>>(this) {
			final ResourceLocation LAYER_TEXTURE = new ResourceLocation("razor_tyrant:textures/entities/razor_tyrant_layer.png");

			@Override
			public void render(PoseStack poseStack, MultiBufferSource bufferSource, int light, RazorTyrantEntity entity, float limbSwing, float limbSwingAmount, float partialTicks, float ageInTicks, float netHeadYaw, float headPitch) {
				VertexConsumer vertexConsumer = bufferSource.getBuffer(RenderType.eyes(LAYER_TEXTURE));
				this.getParentModel().renderToBuffer(poseStack, vertexConsumer, light, LivingEntityRenderer.getOverlayCoords(entity, 0), 1, 1, 1, 1);
			}
		});
	}

	@Override
	protected void scale(RazorTyrantEntity entity, PoseStack poseStack, float f) {
		Level world = entity.level();
		double x = entity.getX();
		double y = entity.getY();
		double z = entity.getZ();
		float scale = (float) RazorTyrantModelVisualScaleProcedure.execute(entity);
		poseStack.scale(scale, scale, scale);
	}

	@Override
	public ResourceLocation getTextureLocation(RazorTyrantEntity entity) {
		return new ResourceLocation("razor_tyrant:textures/entities/razor_tyrant.png");
	}

	private static final class AnimatedModel extends ModelRazor_Tyrant<RazorTyrantEntity> {
		private final ModelPart root;
		private final HierarchicalModel animator = new HierarchicalModel<RazorTyrantEntity>() {
			@Override
			public ModelPart root() {
				return root;
			}

			@Override
			public void setupAnim(RazorTyrantEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
				this.root().getAllParts().forEach(ModelPart::resetPose);
				this.animate(entity.animationState0, Razor_TyrantAnimation.idle, ageInTicks, 1f);
				if (RazorTyrantWalkPlaybackConditionProcedure.execute(entity))
					this.animateWalk(Razor_TyrantAnimation.walk, limbSwing, limbSwingAmount, 1f, 1f);
				this.animate(entity.animationState2, Razor_TyrantAnimation.rightStomp, ageInTicks, 1f);
				this.animate(entity.animationState3, Razor_TyrantAnimation.rightSlash, ageInTicks, 1f);
				this.animate(entity.animationState4, Razor_TyrantAnimation.leftSlash, ageInTicks, 1f);
				this.animate(entity.animationState5, Razor_TyrantAnimation.rightChopping, ageInTicks, 1f);
				this.animate(entity.animationState6, Razor_TyrantAnimation.leftChopping, ageInTicks, 1f);
				this.animate(entity.animationState7, Razor_TyrantAnimation.shootHead, ageInTicks, 1f);
				this.animate(entity.animationState8, Razor_TyrantAnimation.rightLowStab, ageInTicks, 1f);
				this.animate(entity.animationState9, Razor_TyrantAnimation.leftLowStab, ageInTicks, 1f);
				this.animate(entity.animationState10, Razor_TyrantAnimation.rightUpStab, ageInTicks, 1f);
				this.animate(entity.animationState11, Razor_TyrantAnimation.leftUpStab, ageInTicks, 1f);
				this.animate(entity.animationState12, Razor_TyrantAnimation.leap, ageInTicks, 1.25f);
				this.animate(entity.animationState13, Razor_TyrantAnimation.firstEncounter, ageInTicks, 0.75f);
			}
		};

		public AnimatedModel(ModelPart root) {
			super(root);
			this.root = root;
		}

		@Override
		public void setupAnim(RazorTyrantEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
			animator.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
			super.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
		}
	}
}
